package hk.quantr.veriloggraph;

import com.formdev.flatlaf.intellijthemes.FlatArcOrangeIJTheme;
import java.awt.Font;
import java.io.File;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.ImageIcon;
import javax.swing.UIManager;

/**
 *
 * @author Peter <peter@quantr.hk>
 */
public class VerilogGraph extends javax.swing.JFrame {

	/**
	 * Creates new form VerilogGraph
	 */
	public VerilogGraph(String args[]) {
		initComponents();

		if (args.length > 0) {
			if (!new File(args[0]).exists()) {
				System.out.println("java -jar verilog-graph.jar <top module file>");
				System.out.println("Top module not exist, " + args[0]);
				System.exit(1);
			} else if (!new File(args[0]).isFile()) {
				System.out.println("java -jar verilog-graph.jar <top module file>");
				System.out.println("Top module has to be a file, " + args[0]);
				System.exit(1);
			}
			System.out.println("loading " + new File(args[0]));
			setTitle(args[0]);
			quantrVerilogGraphPanel.loadAllVerilog(new File(args[0]));
		} else {
			setTitle("Quantr Verilog Graph");
		}
		try {
			setIconImage(new ImageIcon(Class.forName("hk.quantr.veriloggraph.VerilogGraph").getResource("/logo.png")).getImage());
		} catch (ClassNotFoundException ex) {
			Logger.getLogger(VerilogGraph.class.getName()).log(Level.SEVERE, null, ex);
		}

		setSize(1600, 1000);
		setLocationRelativeTo(null);
	}

	/**
	 * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form
	 * Editor.
	 */
	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        quantrVerilogGraphPanel = new hk.quantr.veriloggraph.QuantrVerilogGraphPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        getContentPane().add(quantrVerilogGraphPanel, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

	/**
	 * @param args the command line arguments
	 */
	public static void main(String args[]) {
//		if (!System.getProperty("os.name").equals("Mac OS X")) {
		try {
			UIManager.setLookAndFeel(new FlatArcOrangeIJTheme());
			UIManager.getLookAndFeelDefaults().put("defaultFont", new Font("Segoe", Font.PLAIN, 16));
		} catch (Exception ex) {
			System.err.println("Failed to initialize LaF");
		}
//		}
		/* Create and display the form */
		java.awt.EventQueue.invokeLater(new Runnable() {
			public void run() {
				new VerilogGraph(args).setVisible(true);
			}
		});
	}

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private hk.quantr.veriloggraph.QuantrVerilogGraphPanel quantrVerilogGraphPanel;
    // End of variables declaration//GEN-END:variables
}
